﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace 电源控制
{
    public partial class Form2 : Form
    {
        #region 参数设置
        const int maxdy = 4000;             //电压的设置范围
        const int mindy = 10;

        const int maxdl = 50;               //电流的设置范围
        const int mindl = 1;

        const int CID1_h = 0x39;            //CID1
        const int CID1_l = 0x30;

        const int prevolt_h = 0x38;         //发送 设置输出电压 命令
        const int prevolt_l = 0x33;

        const int upvolt_h = 0x38;          //发送 设置电压上限 命令
        const int upvolt_l = 0x31;

        const int upcurr_h = 0x38;          //发送 设置电流上限 命令
        const int upcurr_l = 0x33;

        const int start_h = 0x39;           //发送 启动 命令
        const int start_l = 0x31;

        const int stop_h = 0x39;            //发送 停止 命令
        const int stop_l = 0x32;

        const int state_h = 0x39;           //发送 回读电源状态  命令
        const int state_l = 0x33;

        const int dispfreq_h = 0x39;        //发送 回读电源输出频率  命令
        const int dispfreq_l = 0x34;

        const int disvolt_h = 0x39;         //发送 回读电源输出电压  命令
        const int disvolt_l = 0x35;

        const int dispcurr_h = 0x39;        //发送 回读电源输出电流  命令
        const int dispcurr_l = 0x36;

        const int disppower_h = 0x39;       //发送 回读电源输出功率  命令
        const int disppower_l = 0x37;

        const int dispfact_h = 0x39;        //发送 回读电源输出功率因数  命令
        const int dispfact_l = 0x38;

        const int dispall_h = 0x39;         //发送 回读电源输出功率因数  命令
        const int dispall_l = 0x39;
        byte[] fx = new byte[18];
        long he;

        #endregion 参数设置
        byte[] chksum = new byte[4];
        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e) 
        {

            string[] portNs = { "COM1", "COM2", "COM3", "COM4", "COM5" };

            foreach (string portN in portNs)
            {
                toolStripComboBox1.Items.Add(portN);

            }
            string[] Adrrs = { "1", "2" };
            foreach (string Adrr in Adrrs)
            {
                toolStripComboBox3.Items.Add(Adrr);
                toolStripComboBox2.Items.Add(Adrr);
            }

        }

        #region 串口配置
        public SerialPort spPower = new SerialPort();
        public string status2;
        public string[] d = new string[22];
        private StringBuilder builder = new StringBuilder();//避免在事件处理方法中反复的创建，定义到外面。

        public void port_430_init()
        {

            spPower.DataReceived += new SerialDataReceivedEventHandler(spPower_DataReceived);

        }
        public void startPower()
        {
            if (!spPower.IsOpen)
            {
                string portname = toolStripComboBox1.Text; int baudrate = 9600; int databits = 8; Parity parity = Parity.None; StopBits stopbits = StopBits.One;
                spPower.PortName = portname;
                spPower.BaudRate = baudrate;
                spPower.DataBits = databits;
                spPower.Parity = parity;
                spPower.StopBits = stopbits;
                spPower.DtrEnable = true;//若不定义 串口监听不能使
                spPower.RtsEnable = true;//若不定义 串口监听不能使
                try
                {
                    spPower.Open();
                    toolStripStatusLabel1.Text = "串口启动成功";
                }
                catch (Exception error)
                {
                    MessageBox.Show(error.Message);
                }

            }
        }
        #endregion 串口配置
        #region 数据解析
        private void spPower_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {





        }
        #endregion 数据解析
        #region 校验函数
        private void chekN(long K)
        {
            int i;
            long S;
            long[] che = new long[4];
            S = 65536 - K;
            che[0] = S / 4096;
            che[1] = (S % 4096) / 256;
            che[2] = ((S % 4096) % 256) / 16;
            che[3] = ((S % 4096) % 256) % 16;
            for (i = 0; i < 4; i++)
            {
                if ((che[i] >= 0) & (che[i] <= 9))
                {
                    chksum[i] = Convert.ToByte(che[i] + 0x30);

                }
                else if ((che[i] >= 10) & (che[i] <= 15))
                {
                    chksum[i] = Convert.ToByte(che[i] + 0x37);

                }
            }


        }
        #endregion 校验函数

        private void 连接设备ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            string hh;
            startPower();
            if (连接设备ToolStripMenuItem1.Text == "连接设备")
            {
                连接设备ToolStripMenuItem1.Text = "断开设备";
                toolStripComboBox1.Enabled = false;
                toolStripComboBox2.Enabled = false;
                toolStripComboBox3.Enabled = false;
            }
            if (spPower.IsOpen)
            {
                fx[0] = 0x7e;
                hh = toolStripComboBox2.Text;

                fx[1] = Convert.ToByte((Convert.ToInt32(hh) / 16) + 0x30);
                if ((Convert.ToInt32(hh) % 16) >= 10)
                {
                    fx[2] = Convert.ToByte((Convert.ToInt32(hh) % 16) + 0x37);

                }
                else
                {
                    fx[2] = Convert.ToByte((Convert.ToInt32(hh) % 16) + 0x30);

                }
                hh = toolStripComboBox3.Text;
                fx[3] = Convert.ToByte((Convert.ToInt32(hh) / 16) + 0x30);
                if ((Convert.ToInt32(hh) % 16) >= 10)
                {
                    fx[4] = Convert.ToByte((Convert.ToInt32(hh) % 16) + 0x37);

                }
                else
                {
                    fx[4] = Convert.ToByte((Convert.ToInt32(hh) % 16) + 0x30);

                }

                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = state_h;
                fx[8] = state_l;

                fx[9] = 0x30;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x30;
                int c;

                for (c = 1; c < 13; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[13] = chksum[0];
                fx[14] = chksum[1];
                fx[15] = chksum[2];
                fx[16] = chksum[3];
                fx[17] = 0x0d;
                for (c = 0; c < 18; c++)
                {
                    textBox1.Text += " " + fx[c].ToString("x");
                }

                spPower.Write(fx, 0, 18);



            }

        }











    }
}
